package com.honter.allexception;

import com.honter.allexception.ResultInfo;
import com.honter.allexception.ConfCenterException;
import com.honter.config.LogConfig;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * @Author: kevin
 * @Description: 异常统一处理
 * @Date: Created In 2018/4/16 10:25
 */
@ControllerAdvice
public class ExceptionHandler {

    private static final Logger LOGGER = LoggerFactory.getLogger(LogConfig.class);

    @org.springframework.web.bind.annotation.ExceptionHandler(value = Exception.class)
    @ResponseBody
    public ResultInfo handler(Exception e) {
        ResultInfo resultInfo=new ResultInfo();
        LOGGER.error("----ExceptionHandler----:"+e.getMessage());
        if (e instanceof TokenException) {
            resultInfo = ResultInfo.result(2,"TokenException",e.getMessage());
        } else {
            resultInfo = ResultInfo.result(1,"errorException",e.getMessage());
        }
        return resultInfo;
    }
}
