package com.honter.controller;

import com.honter.allexception.TokenException;
import com.honter.mail.MailSend;
import com.honter.model.User;
import com.honter.security.JwtTokenProvider;
import com.honter.service.UserService;
import com.honter.serviceImpl.UserServiceImpl;
import com.honter.util.JwtToken;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.CacheManager;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by admin on 2018/8/9.
 */
@Controller
@RequestMapping(value = "/ceshi/")
@Api(value = "测试接口", description = "测试接口")
public class HelloController{
    @Autowired
    private CacheManager cacheManager;
    @Autowired
    private UserService userService;
    @Autowired
    private JwtTokenProvider tokenProvider;
    @ResponseBody
    @ApiOperation(value = "根据userId查询用户数据", notes = "根据userId查询用户数据")
    @RequestMapping(value = "hello/{userId}", method = RequestMethod.GET, produces = {"application/json"})
    public String getHello(@PathVariable("userId") int userId) throws Exception {
        //从SecurityContextHolder中获取用户信息
        Map<String, Object> securityMap=( Map<String, Object>)SecurityContextHolder.getContext().getAuthentication().getCredentials();
        System.out.println(securityMap);
        //验证Ehcache缓存，新增缓存
        cacheManager.getCache("appCache").put("name","lihongtao");
        if(userId==1){
            throw new NullPointerException();
        }
        if(userId==2){
            throw new Exception("异常2");
        }
        if(userId==3){
            throw new TokenException("异常TokenException");
        }
        User user = userService.queryUserByUserId(userId);
        return user.getUserName();
    }
    @ResponseBody
    @ApiOperation(value = "测试jwtToken", notes = "测试jwtToken")
    @RequestMapping(value = "jwtToken/{tokenId}", method = RequestMethod.GET, produces = {"application/json"})
    public Map<String, Object> getJwtToken(@PathVariable("tokenId") int tokenId) throws Exception {
        //验证Ehcache缓存，获取缓存
        String name= (String) cacheManager.getCache("appCache").get("name").get();
        System.out.println(name);
        Map<String, Object> claim=new HashMap<String, Object>();
        if(tokenId==1){
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("province", "898765");
            map.put("city", "898765");
            map.put("appkey", "HMu1H/cmyKDOiHv41Y9lLROuOlOo+PPG8F4/RotRmNc=");
            map.put("timestamp", new Date().getTime());
            String tokenSECRET= JwtToken.createToken(map);
            claim=JwtToken.verifyToken(tokenSECRET);
        }
        if(tokenId==2){
            claim=JwtToken.verifyToken("wwww");
        }
        if(tokenId==3){
            claim=JwtToken.verifyToken("eyJhcHBrZXkiOiJITXUxSC9jbXlLRE9pSHY0MVk5bExST3VPbE9vK1BQRzhGNC9Sb3RSbU5jPSIsInByb3ZpbmNlIjoiODk4NzY1IiwiY2l0eSI6Ijg5ODc2NSIsImFsZyI6IkhTMjU2IiwidGltZXN0YW1wIjoxNTUyNTI5OTM1MTg1fQ.eyJjbGFpbSI6IntcImFwcGtleVwiOlwiSE11MUgvY215S0RPaUh2NDFZOWxMUk91T2xPbytQUEc4RjQvUm90Um1OYz1cIixcInByb3ZpbmNlXCI6XCI4OTg3NjVcIixcImNpdHlcIjpcIjg5ODc2NVwiLFwidGltZXN0YW1wXCI6MTU1MjUyOTkzNTE4NX0iLCJleHAiOjE1NTI1Mjk5OTUsImlhdCI6MTU1MjUyOTkzNX0._SUJFDFoYFStMX-T_P0LLsgNAWibafpz_Blf3Bnop5E");
        }
        if(tokenId==4){
            throw new NullPointerException();
        }
        if(tokenId==5){
            throw new Exception("异常2");
        }
        return claim;
    }
    @ResponseBody
    @ApiOperation(value = "根据username查询用户数据", notes = "根据username查询用户数据")
    @RequestMapping(value = "login", method = RequestMethod.POST, produces = {"application/json"})
    public String getHello(@RequestParam String username,HttpServletResponse response) throws Exception {
        User user = userService.getUsersByUserName(username);
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("username",username);
        map.put("date",new Date().getTime());
        response.setHeader("Authorization","Bearer "+tokenProvider.createJwtTokenContMap(map));
        return user.getPhone();
    }
    @ResponseBody
    @ApiOperation(value = "测试邮件发送", notes = "测试邮件发送")
    @RequestMapping(value = "mailsend/{content}", method = RequestMethod.GET, produces = {"application/json"})
    public String getHello(@PathVariable("content") String content) throws Exception {
        MailSend.sendMail("吸引力", "li.hongtaolove@163.com", content);
        return "sucess";
    }
}
