package com.honter.security;

import com.honter.model.User;
import com.honter.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Created by Shuangyao
 * 23:08 2018/9/6
 */
@Service
public class UserAuthService {

    @Autowired
    private UserService userService;

    /**
     * Get {@link UserDetails} by user name.
     * @return
     */
    @Transactional
    public UserDetails getUserDetailByUserName(String username){

        User user = userService.getUsersByUserName(username);

        if(user == null){
            throw new UsernameNotFoundException("user + " + username + "not found.");
        }

//        List<String> roleList = this.userRepository.queryUserOwnedRoleCodes(username);
        List<String> roleList =new ArrayList<>();
//        roleList.add("all");
        List<GrantedAuthority> authorities = roleList.stream()
                .map(role -> new SimpleGrantedAuthority(role)).collect(Collectors.toList());
        return new org.springframework.security.core.userdetails
                .User(username,user.getPassword(),authorities);
    }
}
