package com.honter.util;

import com.alibaba.fastjson.JSONObject;
import com.auth0.jwt.JWT;
import com.auth0.jwt.JWTVerifier;
import com.auth0.jwt.algorithms.Algorithm;
import com.auth0.jwt.exceptions.InvalidClaimException;
import com.auth0.jwt.interfaces.Claim;
import com.auth0.jwt.interfaces.DecodedJWT;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.io.UnsupportedEncodingException;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by admin on 2019/3/13.
 */
//@Component
@Configuration
public class JwtToken {
//    @Value("${jwt.SECRET}")
//    public  String SECRET;
//
//    @Value("${jwt.MINUTE}")
//    public  Integer MINUTE;
    private static String SECRET;
    private static Integer MINUTE;
    @Value("${jwt.SECRET}")
    public void setSECRET(String SECRET){
        JwtToken.SECRET=SECRET;
    }
    @Value("${jwt.MINUTE}")
    public void setMINUTE(Integer MINUTE){
        JwtToken.MINUTE=MINUTE;
    }

    /**
     * 生成token
     */
    public static  String createToken(Map<String, Object> map) throws Exception{
        //签发时间
        Date iatDate=new Date();
        //过期时间设置--1分钟
        Calendar nowTime=Calendar.getInstance();
        nowTime.add(Calendar.MINUTE,MINUTE);
        Date expiresDate=nowTime.getTime();
        Map<String, Object> mapHeader = new HashMap<String, Object>();
        mapHeader.put("alg", "HS256");
        mapHeader.put("typ", "JWT");
        String token= JWT.create()
                .withHeader(map)
                .withClaim("claim", JSONObject.toJSON(map).toString())
                .withExpiresAt(expiresDate)//设置过期时间，过期时间必须大于签发时间
                .withIssuedAt(iatDate)//设置签发时间
                .sign(Algorithm.HMAC256(SECRET.getBytes()));
        return token;
    }
    /**
     * 解密token
     */
    public static  Map<String, Object> verifyToken(String token) {
        Map<String, Object> map = new HashMap<String, Object>();
        String claimStr=null;
        try {
            JWTVerifier verifier = JWT.require(Algorithm.HMAC256(SECRET.getBytes())).build();
            DecodedJWT jwt=verifier.verify(token);
            claimStr=jwt.getClaim("claim").asString();
            map=(Map) JSONObject.parse(claimStr);
        } catch (InvalidClaimException e) {
            map.put("claim","InvalidClaim");
        } catch (Exception e) {
            map.put("claim","error");
        }
        return map;
    }
}
